summaryrefslogtreecommitdiff
path: root/tests.build/morphless-chunks.script
diff options
context:
space:
mode:
authorSam Thursfield <sam.thursfield@codethink.co.uk>2013-01-29 11:58:13 +0000
committerSam Thursfield <sam.thursfield@codethink.co.uk>2013-02-20 16:50:05 +0000
commit8d9a939630bc677c2d2e7c4202a400f9bc0ab3ad (patch)
tree5739316c27531d30be13809f61d0e1e4e630abe9 /tests.build/morphless-chunks.script
parentb4d343b46883ef52df656f0f6401dc6bb1d6e8dd (diff)
downloadmorph-8d9a939630bc677c2d2e7c4202a400f9bc0ab3ad.tar.gz
Separate out build tests from general Morph tests
Diffstat (limited to 'tests.build/morphless-chunks.script')
-rwxr-xr-xtests.build/morphless-chunks.script71
1 files changed, 71 insertions, 0 deletions
diff --git a/tests.build/morphless-chunks.script b/tests.build/morphless-chunks.script
new file mode 100755
index 00000000..b5b8f37e
--- /dev/null
+++ b/tests.build/morphless-chunks.script
@@ -0,0 +1,71 @@
+#!/bin/sh
+#
+# Copyright (C) 2012-2013 Codethink Limited
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; version 2 of the License.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License along
+# with this program; if not, write to the Free Software Foundation, Inc.,
+# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+
+
+## Try to build a morphless chunk.
+
+set -eu
+
+# Create an auto-detectable chunk.
+
+mkdir "$DATADIR/morphless"
+cd "$DATADIR/morphless"
+
+touch configure
+chmod +x configure
+# FIXME: If we leave the file empty, busybox sh on ARMv7 fails to execute it.
+echo '#!/bin/sh' > configure
+
+cat << EOF > Makefile
+all install:
+EOF
+
+git init --quiet
+git add *
+git commit --quiet -m initial
+
+
+# Create a stratum that refers to the morphless chunk.
+
+mkdir "$DATADIR/stratum"
+cd "$DATADIR/stratum"
+cat << EOF > alfred.morph
+{
+ "name": "alfred",
+ "kind": "stratum",
+ "chunks": [
+ {
+ "name": "morphless",
+ "repo": "test:morphless",
+ "ref": "master",
+ "build-depends": []
+ }
+ ]
+}
+EOF
+git init --quiet
+git add alfred.morph
+git commit --quiet -m initial
+
+"$SRCDIR/scripts/test-morph" build-morphology test:stratum master alfred
+
+for chunk in "$DATADIR/cache/artifacts/"*.chunk.*
+do
+ echo "$chunk:" | sed 's/[^.]*//'
+ tar -tf "$chunk" | LC_ALL=C sort | sed '/^\.\/./s:^\./::'
+ echo
+done